package ru.dbotthepony.mc.otm.block.entity;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;

public enum RedstoneSetting {
	IGNORED(new TranslatableComponent("otm.gui.redstone.ignored"), new TranslatableComponent("otm.gui.redstone.ignored.description")),
	LOW(new TranslatableComponent("otm.gui.redstone.low"), new TranslatableComponent("otm.gui.redstone.low.description")),
	HIGH(new TranslatableComponent("otm.gui.redstone.high"), new TranslatableComponent("otm.gui.redstone.high.description"));

	public final Component name;
	public final Component description;
	private static final RedstoneSetting[] values = RedstoneSetting.values();

	RedstoneSetting(TranslatableComponent name, TranslatableComponent description) {
		this.name = name;
		this.description = description;
	}

	public RedstoneSetting next() {
		return values[(ordinal() + 1) % values.length];
	}

	public static RedstoneSetting get(int index) {
		if (index < 0 || index > 2) {
			return LOW;
		}

		return values[index];
	}
}
