package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityBatteryBank;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget;

public class BatteryBankMenu extends MatteryMenu {
	protected BlockEntityBatteryBank tile;

	public LevelGaugeWidget battery_widget;
	public BatterySlot[] battery_slots = new BatterySlot[6 * 2];

	public BatteryBankMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null, new SimpleContainer(6 * 2));
	}

	public BatteryBankMenu(int p_38852_, Inventory inventory, BlockEntityBatteryBank tile, Container batteries) {
		super(Registry.Menus.BATTERY_BANK, p_38852_, inventory, tile);
		this.tile = tile;

		if (tile == null || tile.getCapability(MatteryCapability.ENERGY).resolve().isEmpty()) {
			battery_widget = new LevelGaugeWidget(this);
		} else {
			battery_widget = new LevelGaugeWidget(this, tile.getCapability(MatteryCapability.ENERGY).resolve().get());
		}

		for (int row = 0; row < 2; row++) {
			for (int column = 0; column < 6; column++) {
				battery_slots[row * 6 + column] = new BatterySlot(batteries, row * 6 + column, 44 + column * 18, 24 + row * 18);
				addSlot(battery_slots[row * 6 + column]);
			}
		}

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 6 * 2;
	}
}
