package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatteryPowered;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget;

import javax.annotation.Nullable;

abstract public class PoweredMatteryMenu extends MatteryMenu {
	public final BlockEntityMatteryPowered tile;

	public LevelGaugeWidget battery_widget;
	public BatterySlot battery_slot;

	protected PoweredMatteryMenu(
			@Nullable MenuType<?> menuType,
			int containerID,
			Inventory inventory,
			@Nullable BlockEntityMatteryPowered tile
	) {
		super(menuType, containerID, inventory, tile);
		this.tile = tile;

		if (tile == null || tile.getCapability(MatteryCapability.ENERGY).resolve().isEmpty()) {
			battery_widget = new LevelGaugeWidget(this);
		} else {
			battery_widget = new LevelGaugeWidget(this, tile.getCapability(MatteryCapability.ENERGY).resolve().get());
		}
	}

	protected void addBatterySlot() {
		addBatterySlot(10, 66);
	}

	protected void addBatterySlot(int x) {
		addBatterySlot(x, 66);
	}

	protected void addBatterySlot(int x, int y) {
		Container battery_container = tile != null ? tile.battery_container : new SimpleContainer(1);
		battery_slot = new BatterySlot(battery_container, 0, x, y);
		addSlot(battery_slot);
	}
}
