package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterCapacitorBank
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.graph.matter.MatterNetworkGraph
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget

class MatterCapacitorBankMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityMatterCapacitorBank? = null
) : MatteryMenu(
	Registry.Menus.MATTER_CAPACITOR_BANK, p_38852_, inventory, tile
) {
	val matterGauge: LevelGaugeWidget
	val totalMatterGauge: LevelGaugeWidget
	val workSlots = arrayOfNulls<MatterContainerInputSlot>(2 * 6)

	init {
		if (tile == null) {
			matterGauge = LevelGaugeWidget(this)
			totalMatterGauge = LevelGaugeWidget(this)
		} else {
			matterGauge = LevelGaugeWidget(this, tile)
			totalMatterGauge = LevelGaugeWidget(this, {
				(tile.getAsMatterNode().graph as MatterNetworkGraph?)?.getMatterStorageLevel() ?: Fraction.ZERO
			}, {
				(tile.getAsMatterNode().graph as MatterNetworkGraph?)?.getMatterStorageMaxLevel() ?: Fraction.ZERO
			})
		}

		val container = tile?.matterContainer ?: SimpleContainer(2 * 6)

		for (row in 0..1) {
			for (column in 0..5) {
				val slot = MatterContainerInputSlot(container, row * 6 + column)
				workSlots[row * 6 + column] = slot
				addSlot(slot)
			}
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 2 * 6
	}
}