package ru.dbotthepony.mc.otm.menu.widget

import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.menu.data.BooleanDataContainer
import ru.dbotthepony.mc.otm.menu.data.ShortDataContainer

@Suppress("unused")
class ProgressGaugeWidget(menu: MatteryMenu) : AbstractWidget(menu) {
	@JvmField var progress = {0f}
	@JvmField var stuck = {false}
	@JvmField val progressContainer = ShortDataContainer()
	@JvmField val stuckContainer = BooleanDataContainer()

	init {
		addDataSlots(progressContainer)
		addDataSlots(stuckContainer)
	}

	constructor(
		menu: MatteryMenu,
		progress: () -> Float
	) : this(menu) {
		this.progress = progress
	}

	constructor(
		menu: MatteryMenu,
		progress: () -> Float,
		stuck: () -> Boolean,
	) : this(menu) {
		this.progress = progress
		this.stuck = stuck
	}

	override fun updateServer() {
		progressContainer.value = (Math.max(Math.min(progress(), 1f), 0f) * 10_000f).toInt().toShort()
		stuckContainer.value = stuck()
	}

	fun isStuck(): Boolean = stuckContainer.value
	fun percentage(): Float = progressContainer.value / 10_000f
}
